{-|
Module      : Gargantext.Database.Admin.Types.Hyperdata.Padagraph
Description :
Copyright   : (c) CNRS, 2017-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

-}

{-# LANGUAGE TemplateHaskell            #-}

module Gargantext.Database.Admin.Types.Hyperdata.Padagraph
  where

import Gargantext.Prelude
import Gargantext.Database.Admin.Types.Hyperdata.Prelude

------------------------------------------------------------------------
data HyperdataPadagraph =
  HyperdataPadagraph { _hpad_base     :: !Text
                     , _hpad_graph_id :: !Text
                 }
    deriving (Generic)


defaultHyperdataPadagraph :: HyperdataPadagraph
defaultHyperdataPadagraph = HyperdataPadagraph "" ""

------------------------------------------------------------------------
-- Instances
------------------------------------------------------------------------
-- | Specific Gargantext instance
instance Hyperdata HyperdataPadagraph
makeLenses ''HyperdataPadagraph

-- | All Json instances
$(deriveJSON (unPrefix "_hpad_") ''HyperdataPadagraph)

-- | Arbitrary instances for tests
instance Arbitrary HyperdataPadagraph where
  arbitrary = pure defaultHyperdataPadagraph

instance FromField HyperdataPadagraph
  where
    fromField = fromField'

instance QueryRunnerColumnDefault PGJsonb HyperdataPadagraph
  where
    queryRunnerColumnDefault = fieldQueryRunnerColumn

instance ToSchema HyperdataPadagraph where
  declareNamedSchema proxy =
    genericDeclareNamedSchema (unPrefixSwagger "_hpad_") proxy
    & mapped.schema.description ?~ "Frame Hyperdata"
    & mapped.schema.example ?~ toJSON defaultHyperdataPadagraph

